package util;

import java.util.Collection;
import java.util.Collections;

import org.springframework.cache.Cache;
import org.springframework.cache.CacheManager;
import org.springframework.cache.support.AbstractCacheManager;
import org.springframework.context.annotation.Profile;
import org.springframework.stereotype.Component;

/**
 * {@link CacheManager} implementation that dynamically creates {@link LRUMapCache} instances.
 */
@Component
public class LRUMapCacheManager extends AbstractCacheManager {

    private int maxCacheSize = 10_000;

    public void setMaxCacheSize(int cacheMaxSize) {
        this.maxCacheSize = cacheMaxSize;
    }

    @Override
    protected Collection<? extends Cache> loadCaches() {
        return Collections.emptyList();
    }

    @Override
    protected Cache getMissingCache(String name) {
        return new LRUMapCache(name, maxCacheSize);
    }
}
